/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.esquemaoperacional;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.util.Clients;
import org.zkoss.zkplus.databind.BindingListModel;
import org.zkoss.zkplus.databind.BindingListModelList;
import org.zkoss.zul.Button;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Messagebox;

import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.Tramo;
import com.rjconsultores.ventaboletos.entidad.TramoKmServicio;
import com.rjconsultores.ventaboletos.service.ClaseServicioService;
import com.rjconsultores.ventaboletos.service.EmpresaService;
import com.rjconsultores.ventaboletos.service.TramoKmServicioService;
import com.rjconsultores.ventaboletos.service.TramoService;
import com.rjconsultores.ventaboletos.utilerias.RegistroConDependenciaException;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextboxDecimal;

/**
 *
 * @author Administrador
 */
@Controller("editarTramoKmServicioController")
@Scope("prototype")
public class EditarTramoKmServicioController extends MyGenericForwardComposer {

    @Autowired
    private TramoKmServicioService tramoKmServicioService;
    @Autowired
    private EmpresaService empresaService;
    @Autowired
    private TramoService tramoService;
    @Autowired
    private ClaseServicioService claseServicioService;
    private TramoKmServicio tramoKmServicio;
    private MyListbox tramoKmServicioList;
    private Button btnApagar;
    private static Logger log = Logger.getLogger(EditarTramoKmServicioController.class);
    private Combobox cmbTramo;
    private Combobox cmbEmpresa;
    private Combobox cmbClaseServicio;
    private Combobox cmbParadaOrigem;
    private Combobox cmbParadaDestino;
    private MyTextboxDecimal kmPagoCondutor;
    private List<Tramo> lsTramo;
    private List<Empresa> lsEmpresa;
    private List<ClaseServicio> lsClaseServicio;

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    public TramoKmServicio getTramoKmServicio() {
        return tramoKmServicio;
    }

    public void setTramoKmServicio(TramoKmServicio tramoKmServicio) {
        this.tramoKmServicio = tramoKmServicio;
    }

    public List<ClaseServicio> getLsClaseServicio() {
        return lsClaseServicio;
    }

    public void setLsClaseServicio(List<ClaseServicio> lsClaseServicio) {
        this.lsClaseServicio = lsClaseServicio;
    }

    public List<Empresa> getLsEmpresa() {
        return lsEmpresa;
    }

    public void setLsEmpresa(List<Empresa> lsEmpresa) {
        this.lsEmpresa = lsEmpresa;
    }

    public List<Tramo> getLsTramo() {
        return lsTramo;
    }

    public void setLsTramo(List<Tramo> lsTramo) {
        this.lsTramo = lsTramo;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {

        lsEmpresa = empresaService.buscarTodosExceto(UsuarioLogado.getUsuarioLogado().getEmpresa(),-1);
        lsClaseServicio = claseServicioService.buscarTodosExceto(-1);

        super.doAfterCompose(comp);

        tramoKmServicio = (TramoKmServicio) Executions.getCurrent().getArg().get("tramoKmServicio");
        tramoKmServicioList = (MyListbox) Executions.getCurrent().getArg().get("tramoKmServicioList");

        if (tramoKmServicio.getTramokmservicioId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        } else {
            if (tramoKmServicio.getTramo() != null) {
                lsTramo = new ArrayList<Tramo>();
                lsTramo.add(tramoKmServicio.getTramo());
                BindingListModel listModelParada = new BindingListModelList(lsTramo, true);
                cmbTramo.setModel(listModelParada);
            }
        }
    }

    public void onChange$cmbParadaOrigem(Event ev) {
        Comboitem cbiOrigem = cmbParadaOrigem.getSelectedItem();
        if (cbiOrigem != null) {
            Parada origem = (Parada) cbiOrigem.getValue();

            Comboitem cbiDestino = cmbParadaDestino.getSelectedItem();
            if (cbiDestino != null) {
                Parada destino = (Parada) cbiDestino.getValue();

                lsTramo = tramoService.obtenerListPorOrigemDestino(origem, destino);

                if (!lsTramo.isEmpty()) {

                    BindingListModel listModelParada = new BindingListModelList(lsTramo, true);
                    cmbTramo.setModel(listModelParada);

                    cmbTramo.open();
                }
            }
        }
    }

    public void onChange$cmbParadaDestino(Event ev) {

        Comboitem cbiDestino = cmbParadaDestino.getSelectedItem();
        if (cbiDestino != null) {

            Parada destino = (Parada) cbiDestino.getValue();

            Comboitem cbiOrigem = cmbParadaOrigem.getSelectedItem();
            if (cbiOrigem != null) {
                Parada origem = (Parada) cbiOrigem.getValue();

                lsTramo = tramoService.obtenerListPorOrigemDestino(origem, destino);

                if (!lsTramo.isEmpty()) {

                    BindingListModel listModelParada = new BindingListModelList(lsTramo, true);
                    cmbTramo.setModel(listModelParada);

                    cmbTramo.open();
                }
            }
        }
    }

    public void onClick$btnSalvar(Event ev) {

        cmbTramo.getValue();
        cmbEmpresa.getValue();
        cmbClaseServicio.getValue();
        kmPagoCondutor.getValue();

        try {
            tramoKmServicio.setActivo(Boolean.TRUE);
            tramoKmServicio.setFecmodif(Calendar.getInstance().getTime());
            tramoKmServicio.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

            Comboitem cbiEmpresa = cmbEmpresa.getSelectedItem();
            if (cbiEmpresa != null) {
                tramoKmServicio.setEmpresa((Empresa) cbiEmpresa.getValue());
            }

            Comboitem cbiClaseServicio = cmbClaseServicio.getSelectedItem();
            if (cbiClaseServicio != null) {
                tramoKmServicio.setClaseServicio((ClaseServicio) cbiClaseServicio.getValue());
            }
            Comboitem cbiTramo = cmbTramo.getSelectedItem();
            if (cbiTramo != null) {
                tramoKmServicio.setTramo((Tramo) cbiTramo.getValue());

            }

            List<TramoKmServicio> lsTramoKmServicios = tramoKmServicioService.buscar(tramoKmServicio);

            boolean podeSalvar = false;
            if (lsTramoKmServicios.isEmpty()) {
                podeSalvar = true;
            } else {
                if (tramoKmServicio.getTramokmservicioId() != null) {
                    for (TramoKmServicio c : lsTramoKmServicios) {
                        if (c.getTramokmservicioId().equals(tramoKmServicio.getTramokmservicioId())) {
                            podeSalvar = true;
                        }
                    }
                }
            }

            if (podeSalvar) {

                if (tramoKmServicio.getTramokmservicioId() == null) {
                    tramoKmServicioService.suscribir(tramoKmServicio);
                    tramoKmServicioList.addItem(tramoKmServicio);
                } else {
                    tramoKmServicioService.actualizacion(tramoKmServicio);
                    tramoKmServicioList.updateItem(tramoKmServicio);
                }

                Messagebox.show(
                        Labels.getLabel("editarTramoKmServicioController.MSG.suscribirOK"),
                        Labels.getLabel("editarTramoKmServicioController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                closeWindow();
            } else {
                Messagebox.show(
                        Labels.getLabel("MSG.Registro.Existe"),
                        Labels.getLabel("editarTramoKmServicioController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            }

        } catch (Exception ex) {
            log.error(ex);
        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarTramoKmServicioController.MSG.borrarPergunta"),
                    Labels.getLabel("editarTramoKmServicioController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {
                tramoKmServicioService.borrar(tramoKmServicio);

                Messagebox.show(
                        Labels.getLabel("editarTramoKmServicioController.MSG.borrarOK"),
                        Labels.getLabel("editarTramoKmServicioController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                tramoKmServicioList.removeItem(tramoKmServicio);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
            Clients.alert(Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarTramoKmServicioController.window.title"),
                    Messagebox.INFORMATION);
        }
    }
}
